diff --git a/src/etc/pfSense-rc b/src/etc/pfSense-rc
index b32801ae90..8d67311912 100755
--- a/src/etc/pfSense-rc
+++ b/src/etc/pfSense-rc
@@ -499,7 +499,7 @@ fi
 
 # Start packages
 [ -z "$skip_packages" ] \
-	&& /usr/local/sbin/fcgicli -f /etc/rc.start_packages
+	&& /usr/local/sbin/fcgicli -f /etc/rc.start_packages -d "bootup=true"
 
 # Update pkg metadata
 /etc/rc.update_pkg_metadata now
diff --git a/src/etc/rc.start_packages b/src/etc/rc.start_packages
index b082d48114..b65eacec00 100755
--- a/src/etc/rc.start_packages
+++ b/src/etc/rc.start_packages
@@ -48,6 +48,25 @@ if (file_exists("{$g['conf_path']}/needs_package_sync")) {
 
 log_error("Restarting/Starting all packages.");
 
+global $g;
+if (!platform_booting() && ($_GET['bootup'] != true)) {
+	$no_restart_packages = array("bgp", "ospf", "frr", "quagga", "zebra", "bird", "routed");
+} else {
+	$no_restart_packages = array();
+}
+
+function skip_restart($name) {
+	global $no_restart_packages;
+	foreach($no_restart_packages as $nrp_name) {
+		if (stripos($name, $nrp_name) === FALSE) {
+			continue;
+		} else {
+			return true;
+		}
+	}
+	return false;
+}
+
 $rcfiles = glob(RCFILEPREFIX . "*.sh");
 if (!$rcfiles) {
 	$rcfiles = array();
@@ -60,6 +79,10 @@ if (!$rcfiles) {
 
 if (is_array($config['installedpackages']['package'])) {
 	foreach ($config['installedpackages']['package'] as $pkgid => $package) {
+		if (skip_restart($package['name'])) {
+			echo " Not restarting package on skip list: {$package['name']}\n";
+			continue;
+		}
 		echo " Starting package {$package['name']}...";
 		sync_package($package['name']);
 		$internal_name = get_package_internal_name($package);
@@ -72,6 +95,10 @@ if (is_array($config['installedpackages']['package'])) {
 $shell = @popen("/bin/sh", "w");
 if ($shell) {
 	foreach ($rcfiles as $rcfile => $number) {
+		if (skip_restart($rcfile)) {
+			echo "Not restarting script on skip list: {$rcfile}\n";
+			continue;
+		}
 		echo " Starting {$rcfile}...";
 		fwrite($shell, "{$rcfile} start >>/tmp/bootup_messages 2>&1 &");
 		echo "done.\n";
